/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.xpathdemo;

import java.io.File;
import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import javax.xml.namespace.NamespaceContext;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, XPathExpressionException {

        File input = null;

        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro " +
                    "zpracovani, pouzivam books.xml...");

            input = new File("books.xml");
        } else {
            input = new File(args[0]);
        }

        Document doc = getDocument(input);

        //System.out.println( doc.getDocumentElement().getTextContent());
/*
        showSelectedNodeset(doc,
                "//book[(@year > 1990) and (author='Neal Stephenson')]/title/text()");

        showSelectedNodeset(doc,
                "//book[author='Tomáš Pitner' and price > 5]/title/text()");

        showSelectedNodeset(doc,
                "//book[author='Tomáš Pitner']/preceding-sibling::book/title/text()");
*/
        System.out.println("Evaluated as number " +
                selectByXPath(doc, "count(//book)", XPathConstants.NUMBER));

        System.out.println("Evaluated as boolean " +
                selectByXPath(doc, "count(//book)", XPathConstants.BOOLEAN));

        System.out.println("Evaluated as string " +
                selectByXPath(doc, "count(//book)", XPathConstants.STRING));

        Map<String, String> nsMapping = new HashMap<String, String>();
        // add PurchaseOrder NS mapping to prefix po
        nsMapping.put("po", "http://www.marchal.com/2006/po");
        nsMapping.put("xml", "http://www.w3.org/XML/1998/namespace");
        nsMapping.put("xmlns", "http://www.w3.org/2000/xmlns/");

        Document purchasesDoc = getDocument(new File("purchase.xml"));
        showSelectedNodesetNS(purchasesDoc,
                "//po:Price/text()",
                nsMapping);

    }

    private static Document getDocument(File input) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setNamespaceAware(true); // never forget this!
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.parse(input);
        return doc;
    }

    private static Object selectByXPath(Document doc, String path, QName resultType) throws XPathExpressionException {
        XPathFactory factory = XPathFactory.newInstance();
        XPath xpath = factory.newXPath();
        XPathExpression expr = xpath.compile(path);
        return expr.evaluate(doc, resultType);
    }

    private static void show(NodeList nodes) {
        for (int i = 0; i < nodes.getLength(); i++) {
            System.out.println("Node #" + i + ". " + nodes.item(i));
        }
    }

    private static void showSelectedNodeset(Document doc, String expr)
            throws XPathExpressionException {
        show((NodeList) selectByXPath(doc, expr, XPathConstants.NODESET));
    }

    private static void showSelectedNodesetNS(Document doc,
            String expr,
            final Map<String, String> nsMapping)
            throws XPathExpressionException {

        show((NodeList) selectByXPathNS(doc,
                expr, XPathConstants.NODESET, nsMapping));
    }

    private static Object selectByXPathNS(Document doc,
            String path,
            QName resultType,
            final Map<String, String> nsMapping)
            throws XPathExpressionException {

        XPathFactory factory = XPathFactory.newInstance();
        XPath xpath = factory.newXPath();
        xpath.setNamespaceContext(new NamespaceContext() {

            public String getNamespaceURI(String prefix) {
                if (prefix == null) {
                    throw new IllegalArgumentException(
                            "Do not have a prefix for prefix null");
                } else {
                    return nsMapping.get(prefix);
                }
            }

            public String getPrefix(String namespaceURI) {
                if (namespaceURI == null) {
                    throw new IllegalArgumentException(
                            "Do not have a prefix for NS URI null");
                } else {
                    for (Map.Entry<String, String> mapping : nsMapping.entrySet()) {
                        if (namespaceURI.equals(mapping.getValue())) {
                            return mapping.getKey();
                        }
                    }
                    return null;
                }
            }

            public Iterator getPrefixes(String namespaceURI) {
                Collection<String> prefixes = new HashSet<String>();
                for (Map.Entry<String, String> mapping : nsMapping.entrySet()) {
                    if (namespaceURI.equals(mapping.getValue())) {
                        prefixes.add(mapping.getKey());
                    }
                }
                return prefixes.iterator();
            }
        });
        XPathExpression expr = xpath.compile(path);
        return expr.evaluate(doc, resultType);
    }
}
